#include "mil.h"
#include "mwinmil.h"
#include "milsetup.h"
#include "milerr.h"

	long		SizeX;						// Buffer Size X
	long		SizeY;						// Buffer Size Y
	long		DigSizeX;					// Digitizer input width
	long		DigSizeY;					// Digitizer input heigh
	long		Band;				      // Number of input color bands of the digitizer
	//CView   *GrabInViewPtr;		// Pointer to the view that has the grab
	long		NumberOfDigitizer;// Number of digitizers available on the system
  MIL_ID 	MilApplication;		// Application identifier.  
  MIL_ID 	MilSystem;     		// System identifier.       
	MIL_ID 	MilDigitizer;			// Digitizer identifier.
	MIL_ID MilImage;					//Image buffer identifier.
	//MIL_ID MilDisplay;
	long BufferAttributes;		// Buffer attributes that will be allocated
	MAPPHOOKFCTPTR HandlerPtr;
	void* HandlerUserPtr;
	short ERR,m_iL,m_iH;

//________________________________________
//Prototypes
long MFTYPE DisplayError(long HookType, MIL_ID EventId, void MPTYPE *UserDataPtr);
short InitOrion(short *L,short *H);
short TestOrion(void);
void LibereOrion(void);
void FigerOrion(unsigned char *r,unsigned char *g,unsigned char *b); 
void GetPixelRouge(unsigned char *r); 
void GetPixelRGB(unsigned char *r,unsigned char *g,unsigned char *b); 


short INIT_CARTE(void);
short LIT_IMAGE(long *m_R);
void QUITTE(void);
//________________________________________
short INIT_CARTE(void)
{
	short err;
	//CString z;
	err=InitOrion(&m_iL,&m_iH);
	ERR=err;
	return err;
}
//________________________________________
short LIT_IMAGE(long *m_R)
{
	unsigned char *R,*G,*B;
	if (ERR==0)
	{
		R=new unsigned char[m_iL*m_iH];
		G=new unsigned char[m_iL*m_iH];
		B=new unsigned char[m_iL*m_iH];

		long i;
		GetPixelRGB(R,G,B);
		for (i=0;i<m_iL*m_iH;i++)
		{
			m_R[i]=R[i];
		}
		delete R;delete G;delete B;
	}
	return ERR;
}
//________________________________________
void QUITTE(void)
{
	LibereOrion();
}
//________________________________________
long MFTYPE DisplayError(long HookType, MIL_ID EventId, void MPTYPE *UserDataPtr)
{
	char 	ErrorMessageFunction[M_ERROR_MESSAGE_SIZE] = "";
	char 	ErrorMessage[M_ERROR_MESSAGE_SIZE]         = "";
	char 	ErrorSubMessage1[M_ERROR_MESSAGE_SIZE]     = "";
	char 	ErrorSubMessage2[M_ERROR_MESSAGE_SIZE]     = "";
	char 	ErrorSubMessage3[M_ERROR_MESSAGE_SIZE]     = "";
	long 	NbSubCode;
	char	CErrorMessage[128];

	MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_FCT,ErrorMessageFunction);
	MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT,ErrorMessage);
	MappGetHookInfo(EventId,M_CURRENT_SUB_NB,&NbSubCode);	
	if (NbSubCode > 2)
		MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_3,ErrorSubMessage3);	
	if (NbSubCode > 1)	
		MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_2,ErrorSubMessage2);
   if (NbSubCode > 0)
	   MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_1,ErrorSubMessage1);

	sprintf(CErrorMessage,"%s",ErrorMessageFunction);
	sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
	sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorMessage);
	if(NbSubCode > 0)
	{
		sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
		sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorSubMessage1);
	}
	if(NbSubCode > 1)
	{
		sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
		sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorSubMessage2);
	}
	if(NbSubCode > 2)
	{
		sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
		sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorSubMessage3);
	}
	// Chain hook function
 	if(HandlerPtr)
 		(*HandlerPtr)(HookType,EventId,HandlerUserPtr);
	return M_NULL;
}

//________________________________________
short InitOrion(short *L,short *H)
{
	short err;
	//Allocate an application
	if (MappAlloc(M_DEFAULT,&MilApplication)) err=0; else err=1;
	if (err==0)
	{
		//Disable MIL error message to be displayed as the usual way
		MappControl(M_ERROR,M_PRINT_DISABLE);
		//Retrieve previous hanler ptr and user handler ptr
		MappInquire(M_CURRENT_ERROR_HANDLER_PTR,&HandlerPtr);		
		MappInquire(M_CURRENT_ERROR_HANDLER_USER_PTR,&HandlerUserPtr);	
		//Hook MIL error on function DisplayError()
		//MappHookFunction(M_ERROR_CURRENT,DisplayError,UserDataPtr);
		//Allocate a system	
		if (MsysAlloc(M_SYSTEM_SETUP,M_DEF_SYSTEM_NUM,M_COMPLETE,&MilSystem))
		{
			//Inquire number of digitizers available on the system
			MsysInquire(MilSystem,M_DIGITIZER_NUM,&NumberOfDigitizer);
			//Digitizer is available
			if (NumberOfDigitizer)	
			{
				//Allocate a digitizer
				MdigAlloc(MilSystem,M_DEFAULT,M_CAMERA_SETUP,M_DEFAULT,&MilDigitizer);
				//Stop live grab when window is disable
				MsysControl(MilSystem,M_STOP_LIVE_GRAB_WHEN_DISABLED,M_ENABLE);
				//Inquire digitizer informations
				MdigInquire(MilDigitizer,M_SIZE_X,&DigSizeX);
				MdigInquire(MilDigitizer,M_SIZE_Y,&DigSizeY);  	
				MdigInquire(MilDigitizer,M_SIZE_BAND,&Band);
				//Voir format d'acquisition CCIR par dfaut, fichier milsetup.h
				//CString z;z.Format("DigSizeX:%d, DigSizeY:%d, Band:%d",DigSizeX,DigSizeY,Band);AfxMessageBox(z);
				if (DigSizeX> M_DEF_IMAGE_SIZE_X_MAX) DigSizeX=M_DEF_IMAGE_SIZE_X_MAX;
				if (DigSizeY>M_DEF_IMAGE_SIZE_Y_MAX) 	DigSizeY=M_DEF_IMAGE_SIZE_Y_MAX;
				*H=DigSizeY;*L=DigSizeX;
			}
			else
			{
				//Erreur MsysInquire
				err=3;
				*L=SizeX=M_DEF_IMAGE_SIZE_X_MIN;
				*H=SizeY=M_DEF_IMAGE_SIZE_Y_MIN;
				Band=M_DEF_IMAGE_NUMBANDS_MIN;
			}
		}
		else
		{
			//Erreur MsysAlloc
			err=2;
			*L=SizeX=M_DEF_IMAGE_SIZE_X_MIN;
			*H=SizeY=M_DEF_IMAGE_SIZE_Y_MIN;
			Band=M_DEF_IMAGE_NUMBANDS_MIN;
		}
	}
	if (err==0)
	{
		//Carte prsente
		//Set SizeX and SizeY variables
		if(NumberOfDigitizer)
		{
			*L=SizeX=DigSizeX;
			*H=SizeY=DigSizeY;
		}
		//Allocate a buffer
		//Set buffer attributes
		if(NumberOfDigitizer)
		{
			BufferAttributes=M_IMAGE+M_DISP+M_GRAB+M_PROC;
		}
		else
		{
			BufferAttributes=M_IMAGE+M_DISP+M_PROC;
			err=4;
		}
		if (err==0)
		{
			MbufAllocColor(MilSystem,Band,SizeX,SizeY,M_DEF_IMAGE_TYPE,BufferAttributes,&MilImage);
			//If not able to allocate a buffer, do not create a new document
			if(MilImage)
			{
				//Clear the buffer 
				MbufClear(MilImage,0);
			}
			else
			{
				//Erreur MbufAllocColor
				//*L=-1;
				//*H=-1;
				err=5;
			}
		}
	}
	else
	{
		//Carte Matrox Orion non prsente
		//*L=-1;
		//*H=-1;
	}
	return err;
}
//________________________________________
short TestOrion(void)
{
	short err;
	//Allocate an application
	if (MappAlloc(M_DEFAULT,&MilApplication)) err=0; else err=1;
	if (err==0)
	{
		//Disable MIL error message to be displayed as the usual way
		MappControl(M_ERROR,M_PRINT_DISABLE);
		//Retrieve previous hanler ptr and user handler ptr
		MappInquire(M_CURRENT_ERROR_HANDLER_PTR,&HandlerPtr);		
		MappInquire(M_CURRENT_ERROR_HANDLER_USER_PTR,&HandlerUserPtr);	
		//Hook MIL error on function DisplayError()
		//MappHookFunction(M_ERROR_CURRENT,DisplayError,UserDataPtr);
		//Allocate a system	
		if (MsysAlloc(M_SYSTEM_SETUP,M_DEF_SYSTEM_NUM,M_COMPLETE,&MilSystem))
		{
			err=0;
			MsysFree(MilSystem);
		}
		else
		{
			err=2;
		}
		MappFree(MilApplication);
	}
	return err;
}
//________________________________________
void LibereOrion(void)
{
	if(MilImage) MbufFree(MilImage);
	//if (MilDisplay) MdispFree(MilDisplay);
	/*if (MilDigitizer)*/ MdigFree(MilDigitizer);
	MsysFree(MilSystem);
	MappFree(MilApplication);
}
//________________________________________
void GetPixelRouge(unsigned char *r) 
{
	const long larg=SizeX;
	const long haut=SizeY;
	MdigHalt(MilDigitizer);	
	MbufGetColor2d(MilImage,M_SINGLE_BAND,M_RED,0,0,larg,haut,r);
	MdigGrabContinuous(MilDigitizer,MilImage);
}
//________________________________________
void GetPixelRGB(unsigned char *r,unsigned char *g,unsigned char *b) 
{

	const long larg=SizeX;
	const long haut=SizeY;
	MdigHalt(MilDigitizer);	
	MbufGetColor2d(MilImage,M_SINGLE_BAND,M_RED,0,0,larg,haut,r);
	MbufGetColor2d(MilImage,M_SINGLE_BAND,M_GREEN,0,0,larg,haut,g);
	MbufGetColor2d(MilImage,M_SINGLE_BAND,M_BLUE,0,0,larg,haut,b);
	MdigGrabContinuous(MilDigitizer,MilImage);
}
